"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.EditBuilder = void 0;
class EditBuilder {
    constructor(changeFamily, changeReceiver) {
        this.changeFamily = changeFamily;
        this.changeReceiver = changeReceiver;
    }
    /**
     * Subclasses add editing methods which call this with their generated edits.
     *
     * @sealed
     */
    applyChange(change) {
        this.changeReceiver(change);
    }
    enterTransaction() { }
    exitTransaction() { }
}
exports.EditBuilder = EditBuilder;
//# sourceMappingURL=editBuilder.js.map