"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeForest = exports.ITreeSubscriptionCursorState = exports.TreeNavigationResult = exports.aboveRootPlaceholder = exports.getDetachedFieldContainingPath = exports.DetachedFieldIndex = exports.isCursor = exports.CursorMarker = exports.inCursorNode = exports.inCursorField = exports.anchorSlot = exports.emptyDelta = exports.offsetDetachId = exports.makeDetachedNodeId = exports.isEmptyFieldChanges = exports.emptyFieldChanges = exports.deltaForSet = exports.deltaForRootInitialization = exports.forEachField = exports.forEachNodeInSubtree = exports.forEachNode = exports.compareFieldUpPaths = exports.topDownPath = exports.clonePath = exports.compareUpPaths = exports.getDescendant = exports.SparseNode = exports.setGenericTreeField = exports.makeDetachedFieldIndex = exports.applyDelta = exports.announceDelta = exports.combineVisitors = exports.visitDelta = exports.keyAsDetachedField = exports.detachedFieldAsKey = exports.getMapTreeField = exports.iterateCursorField = exports.mapCursorFields = exports.mapCursorField = exports.getDepth = exports.genericTreeDeleteIfEmpty = exports.getGenericTreeField = exports.genericTreeKeys = exports.castCursorToSynchronous = exports.CursorLocationType = exports.rootField = exports.rootFieldKey = exports.EncodedJsonableTree = exports.AnchorSet = exports.EmptyKey = void 0;
exports.DiscardResult = exports.RevertResult = exports.RevertibleKind = exports.AllowedUpdateType = exports.Compatibility = exports.AdaptedViewSchema = exports.revisionMetadataSourceFromInfo = exports.rebaseChangeOverChanges = exports.rebaseChange = exports.rebaseBranch = exports.mintCommit = exports.SessionIdSchema = exports.tagRollbackInverse = exports.verifyChangeRebaser = exports.noFailure = exports.mapTaggedChange = exports.tagChange = exports.makeAnonChange = exports.RevisionTagCodec = exports.RevisionTagSchema = exports.findCommonAncestor = exports.findAncestor = exports.areEqualChangeAtomIds = exports.EditBuilder = exports.storedSchemaDecodeDispatcher = exports.encodeFieldSchema = exports.decodeFieldSchema = exports.MapNodeStoredSchema = exports.ObjectNodeStoredSchema = exports.LeafNodeStoredSchema = exports.schemaFormat = exports.storedEmptyFieldSchema = exports.forbiddenFieldKindIdentifier = exports.schemaDataIsEmpty = exports.TreeStoredSchemaRepository = exports.TreeNodeStoredSchema = exports.ValueSchema = exports.moveToDetachedField = void 0;
var tree_1 = require("./tree");
Object.defineProperty(exports, "EmptyKey", { enumerable: true, get: function () { return tree_1.EmptyKey; } });
Object.defineProperty(exports, "AnchorSet", { enumerable: true, get: function () { return tree_1.AnchorSet; } });
Object.defineProperty(exports, "EncodedJsonableTree", { enumerable: true, get: function () { return tree_1.EncodedJsonableTree; } });
Object.defineProperty(exports, "rootFieldKey", { enumerable: true, get: function () { return tree_1.rootFieldKey; } });
Object.defineProperty(exports, "rootField", { enumerable: true, get: function () { return tree_1.rootField; } });
Object.defineProperty(exports, "CursorLocationType", { enumerable: true, get: function () { return tree_1.CursorLocationType; } });
Object.defineProperty(exports, "castCursorToSynchronous", { enumerable: true, get: function () { return tree_1.castCursorToSynchronous; } });
Object.defineProperty(exports, "genericTreeKeys", { enumerable: true, get: function () { return tree_1.genericTreeKeys; } });
Object.defineProperty(exports, "getGenericTreeField", { enumerable: true, get: function () { return tree_1.getGenericTreeField; } });
Object.defineProperty(exports, "genericTreeDeleteIfEmpty", { enumerable: true, get: function () { return tree_1.genericTreeDeleteIfEmpty; } });
Object.defineProperty(exports, "getDepth", { enumerable: true, get: function () { return tree_1.getDepth; } });
Object.defineProperty(exports, "mapCursorField", { enumerable: true, get: function () { return tree_1.mapCursorField; } });
Object.defineProperty(exports, "mapCursorFields", { enumerable: true, get: function () { return tree_1.mapCursorFields; } });
Object.defineProperty(exports, "iterateCursorField", { enumerable: true, get: function () { return tree_1.iterateCursorField; } });
Object.defineProperty(exports, "getMapTreeField", { enumerable: true, get: function () { return tree_1.getMapTreeField; } });
Object.defineProperty(exports, "detachedFieldAsKey", { enumerable: true, get: function () { return tree_1.detachedFieldAsKey; } });
Object.defineProperty(exports, "keyAsDetachedField", { enumerable: true, get: function () { return tree_1.keyAsDetachedField; } });
Object.defineProperty(exports, "visitDelta", { enumerable: true, get: function () { return tree_1.visitDelta; } });
Object.defineProperty(exports, "combineVisitors", { enumerable: true, get: function () { return tree_1.combineVisitors; } });
Object.defineProperty(exports, "announceDelta", { enumerable: true, get: function () { return tree_1.announceDelta; } });
Object.defineProperty(exports, "applyDelta", { enumerable: true, get: function () { return tree_1.applyDelta; } });
Object.defineProperty(exports, "makeDetachedFieldIndex", { enumerable: true, get: function () { return tree_1.makeDetachedFieldIndex; } });
Object.defineProperty(exports, "setGenericTreeField", { enumerable: true, get: function () { return tree_1.setGenericTreeField; } });
Object.defineProperty(exports, "SparseNode", { enumerable: true, get: function () { return tree_1.SparseNode; } });
Object.defineProperty(exports, "getDescendant", { enumerable: true, get: function () { return tree_1.getDescendant; } });
Object.defineProperty(exports, "compareUpPaths", { enumerable: true, get: function () { return tree_1.compareUpPaths; } });
Object.defineProperty(exports, "clonePath", { enumerable: true, get: function () { return tree_1.clonePath; } });
Object.defineProperty(exports, "topDownPath", { enumerable: true, get: function () { return tree_1.topDownPath; } });
Object.defineProperty(exports, "compareFieldUpPaths", { enumerable: true, get: function () { return tree_1.compareFieldUpPaths; } });
Object.defineProperty(exports, "forEachNode", { enumerable: true, get: function () { return tree_1.forEachNode; } });
Object.defineProperty(exports, "forEachNodeInSubtree", { enumerable: true, get: function () { return tree_1.forEachNodeInSubtree; } });
Object.defineProperty(exports, "forEachField", { enumerable: true, get: function () { return tree_1.forEachField; } });
Object.defineProperty(exports, "deltaForRootInitialization", { enumerable: true, get: function () { return tree_1.deltaForRootInitialization; } });
Object.defineProperty(exports, "deltaForSet", { enumerable: true, get: function () { return tree_1.deltaForSet; } });
Object.defineProperty(exports, "emptyFieldChanges", { enumerable: true, get: function () { return tree_1.emptyFieldChanges; } });
Object.defineProperty(exports, "isEmptyFieldChanges", { enumerable: true, get: function () { return tree_1.isEmptyFieldChanges; } });
Object.defineProperty(exports, "makeDetachedNodeId", { enumerable: true, get: function () { return tree_1.makeDetachedNodeId; } });
Object.defineProperty(exports, "offsetDetachId", { enumerable: true, get: function () { return tree_1.offsetDetachId; } });
Object.defineProperty(exports, "emptyDelta", { enumerable: true, get: function () { return tree_1.emptyDelta; } });
Object.defineProperty(exports, "anchorSlot", { enumerable: true, get: function () { return tree_1.anchorSlot; } });
Object.defineProperty(exports, "inCursorField", { enumerable: true, get: function () { return tree_1.inCursorField; } });
Object.defineProperty(exports, "inCursorNode", { enumerable: true, get: function () { return tree_1.inCursorNode; } });
Object.defineProperty(exports, "CursorMarker", { enumerable: true, get: function () { return tree_1.CursorMarker; } });
Object.defineProperty(exports, "isCursor", { enumerable: true, get: function () { return tree_1.isCursor; } });
Object.defineProperty(exports, "DetachedFieldIndex", { enumerable: true, get: function () { return tree_1.DetachedFieldIndex; } });
Object.defineProperty(exports, "getDetachedFieldContainingPath", { enumerable: true, get: function () { return tree_1.getDetachedFieldContainingPath; } });
Object.defineProperty(exports, "aboveRootPlaceholder", { enumerable: true, get: function () { return tree_1.aboveRootPlaceholder; } });
var forest_1 = require("./forest");
Object.defineProperty(exports, "TreeNavigationResult", { enumerable: true, get: function () { return forest_1.TreeNavigationResult; } });
Object.defineProperty(exports, "ITreeSubscriptionCursorState", { enumerable: true, get: function () { return forest_1.ITreeSubscriptionCursorState; } });
Object.defineProperty(exports, "initializeForest", { enumerable: true, get: function () { return forest_1.initializeForest; } });
Object.defineProperty(exports, "moveToDetachedField", { enumerable: true, get: function () { return forest_1.moveToDetachedField; } });
var schema_stored_1 = require("./schema-stored");
Object.defineProperty(exports, "ValueSchema", { enumerable: true, get: function () { return schema_stored_1.ValueSchema; } });
Object.defineProperty(exports, "TreeNodeStoredSchema", { enumerable: true, get: function () { return schema_stored_1.TreeNodeStoredSchema; } });
Object.defineProperty(exports, "TreeStoredSchemaRepository", { enumerable: true, get: function () { return schema_stored_1.TreeStoredSchemaRepository; } });
Object.defineProperty(exports, "schemaDataIsEmpty", { enumerable: true, get: function () { return schema_stored_1.schemaDataIsEmpty; } });
Object.defineProperty(exports, "forbiddenFieldKindIdentifier", { enumerable: true, get: function () { return schema_stored_1.forbiddenFieldKindIdentifier; } });
Object.defineProperty(exports, "storedEmptyFieldSchema", { enumerable: true, get: function () { return schema_stored_1.storedEmptyFieldSchema; } });
Object.defineProperty(exports, "schemaFormat", { enumerable: true, get: function () { return schema_stored_1.schemaFormat; } });
Object.defineProperty(exports, "LeafNodeStoredSchema", { enumerable: true, get: function () { return schema_stored_1.LeafNodeStoredSchema; } });
Object.defineProperty(exports, "ObjectNodeStoredSchema", { enumerable: true, get: function () { return schema_stored_1.ObjectNodeStoredSchema; } });
Object.defineProperty(exports, "MapNodeStoredSchema", { enumerable: true, get: function () { return schema_stored_1.MapNodeStoredSchema; } });
Object.defineProperty(exports, "decodeFieldSchema", { enumerable: true, get: function () { return schema_stored_1.decodeFieldSchema; } });
Object.defineProperty(exports, "encodeFieldSchema", { enumerable: true, get: function () { return schema_stored_1.encodeFieldSchema; } });
Object.defineProperty(exports, "storedSchemaDecodeDispatcher", { enumerable: true, get: function () { return schema_stored_1.storedSchemaDecodeDispatcher; } });
var change_family_1 = require("./change-family");
Object.defineProperty(exports, "EditBuilder", { enumerable: true, get: function () { return change_family_1.EditBuilder; } });
var rebase_1 = require("./rebase");
Object.defineProperty(exports, "areEqualChangeAtomIds", { enumerable: true, get: function () { return rebase_1.areEqualChangeAtomIds; } });
Object.defineProperty(exports, "findAncestor", { enumerable: true, get: function () { return rebase_1.findAncestor; } });
Object.defineProperty(exports, "findCommonAncestor", { enumerable: true, get: function () { return rebase_1.findCommonAncestor; } });
Object.defineProperty(exports, "RevisionTagSchema", { enumerable: true, get: function () { return rebase_1.RevisionTagSchema; } });
Object.defineProperty(exports, "RevisionTagCodec", { enumerable: true, get: function () { return rebase_1.RevisionTagCodec; } });
Object.defineProperty(exports, "makeAnonChange", { enumerable: true, get: function () { return rebase_1.makeAnonChange; } });
Object.defineProperty(exports, "tagChange", { enumerable: true, get: function () { return rebase_1.tagChange; } });
Object.defineProperty(exports, "mapTaggedChange", { enumerable: true, get: function () { return rebase_1.mapTaggedChange; } });
Object.defineProperty(exports, "noFailure", { enumerable: true, get: function () { return rebase_1.noFailure; } });
Object.defineProperty(exports, "verifyChangeRebaser", { enumerable: true, get: function () { return rebase_1.verifyChangeRebaser; } });
Object.defineProperty(exports, "tagRollbackInverse", { enumerable: true, get: function () { return rebase_1.tagRollbackInverse; } });
Object.defineProperty(exports, "SessionIdSchema", { enumerable: true, get: function () { return rebase_1.SessionIdSchema; } });
Object.defineProperty(exports, "mintCommit", { enumerable: true, get: function () { return rebase_1.mintCommit; } });
Object.defineProperty(exports, "rebaseBranch", { enumerable: true, get: function () { return rebase_1.rebaseBranch; } });
Object.defineProperty(exports, "rebaseChange", { enumerable: true, get: function () { return rebase_1.rebaseChange; } });
Object.defineProperty(exports, "rebaseChangeOverChanges", { enumerable: true, get: function () { return rebase_1.rebaseChangeOverChanges; } });
Object.defineProperty(exports, "revisionMetadataSourceFromInfo", { enumerable: true, get: function () { return rebase_1.revisionMetadataSourceFromInfo; } });
var schema_view_1 = require("./schema-view");
Object.defineProperty(exports, "AdaptedViewSchema", { enumerable: true, get: function () { return schema_view_1.AdaptedViewSchema; } });
Object.defineProperty(exports, "Compatibility", { enumerable: true, get: function () { return schema_view_1.Compatibility; } });
Object.defineProperty(exports, "AllowedUpdateType", { enumerable: true, get: function () { return schema_view_1.AllowedUpdateType; } });
var revertible_1 = require("./revertible");
Object.defineProperty(exports, "RevertibleKind", { enumerable: true, get: function () { return revertible_1.RevertibleKind; } });
Object.defineProperty(exports, "RevertResult", { enumerable: true, get: function () { return revertible_1.RevertResult; } });
Object.defineProperty(exports, "DiscardResult", { enumerable: true, get: function () { return revertible_1.DiscardResult; } });
//# sourceMappingURL=index.js.map