"use strict";
/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.FinalChangeStatus = exports.makeAnonChange = exports.tagRollbackInverse = exports.tagChange = exports.mapTaggedChange = void 0;
function mapTaggedChange(input, change) {
    return { ...input, change };
}
exports.mapTaggedChange = mapTaggedChange;
function tagChange(change, revision) {
    return { revision, change };
}
exports.tagChange = tagChange;
function tagRollbackInverse(inverseChange, revision, rollbackOf) {
    return {
        revision,
        change: inverseChange,
        rollbackOf,
    };
}
exports.tagRollbackInverse = tagRollbackInverse;
function makeAnonChange(change) {
    return { revision: undefined, change };
}
exports.makeAnonChange = makeAnonChange;
var FinalChangeStatus;
(function (FinalChangeStatus) {
    FinalChangeStatus[FinalChangeStatus["conflicted"] = 0] = "conflicted";
    FinalChangeStatus[FinalChangeStatus["rebased"] = 1] = "rebased";
    FinalChangeStatus[FinalChangeStatus["commuted"] = 2] = "commuted";
})(FinalChangeStatus || (exports.FinalChangeStatus = FinalChangeStatus = {}));
//# sourceMappingURL=changeRebaser.js.map