/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { IIdCompressor, SessionId } from "@fluidframework/id-compressor";
import { SessionAwareCodec } from "../../codec";
import { EncodedRevisionTag, RevisionTag } from "./types";
export declare class RevisionTagCodec implements SessionAwareCodec<RevisionTag, EncodedRevisionTag> {
    private readonly idCompressor;
    constructor(idCompressor: IIdCompressor);
    encode(tag: RevisionTag): EncodedRevisionTag;
    decode(tag: EncodedRevisionTag, originatorId: SessionId): RevisionTag;
}
//# sourceMappingURL=revisionTagCodec.d.ts.map