/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { StoredSchemaCollection } from "../../../core";
import { JsonCompatibleReadOnly } from "../../../util";
import { ICodecOptions, IJsonCodec } from "../../../codec";
import { FullSchemaPolicy } from "../../modular-schema";
import { TreeCompressionStrategy } from "../../treeCompressionUtils";
import { EncodedFieldBatch } from "./format";
import { FieldBatch } from "./fieldBatch";
export interface Context {
    readonly encodeType: TreeCompressionStrategy;
    readonly schema?: SchemaAndPolicy;
}
export interface SchemaAndPolicy {
    readonly schema: StoredSchemaCollection;
    readonly policy: FullSchemaPolicy;
}
export type FieldBatchCodec = IJsonCodec<FieldBatch, EncodedFieldBatch, JsonCompatibleReadOnly>;
export declare function makeFieldBatchCodec(options: ICodecOptions, context: Context): FieldBatchCodec;
//# sourceMappingURL=codecs.d.ts.map