/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { SessionId } from "@fluidframework/id-compressor";
import { ICodecFamily, SessionAwareCodec } from "../../codec";
import { EncodedRevisionTag, RevisionTag } from "../../core";
import type { NodeChangeset } from "../modular-schema";
import type { OptionalChangeset } from "./optionalFieldChangeTypes";
export declare const noChangeCodecFamily: ICodecFamily<0, SessionId>;
export declare const makeOptionalFieldCodecFamily: <TChildChange = NodeChangeset>(childCodec: SessionAwareCodec<TChildChange>, revisionTagCodec: SessionAwareCodec<RevisionTag, EncodedRevisionTag>) => ICodecFamily<OptionalChangeset<TChildChange>, SessionId>;
//# sourceMappingURL=optionalFieldCodecs.d.ts.map