/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { Mark, MarkList } from "./types";
/**
 * Helper class for constructing an offset list of marks that...
 * - Does not insert offsets if there is no content after them
 * - Does not insert 0-sized offsets
 * - Merges runs of offsets together
 * - Merges marks together
 */
export declare class MarkListFactory<TNodeChange> {
    private offset;
    readonly list: MarkList<TNodeChange>;
    constructor();
    push(...marks: Mark<TNodeChange>[]): void;
    pushOffset(offset: number): void;
    pushContent(mark: Mark<TNodeChange>): void;
}
//# sourceMappingURL=markListFactory.d.ts.map