/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
import { IFluidHandle } from "@fluidframework/core-interfaces";
import { Value, ValueSchema, TreeValue } from "../core";
export declare function allowsValue(schema: ValueSchema | undefined, nodeValue: Value): boolean;
export declare function valueSchemaAllows<TSchema extends ValueSchema>(schema: TSchema, nodeValue: Value): nodeValue is TreeValue<TSchema>;
/**
 * Use for readonly view of Json compatible data that can also contain IFluidHandles.
 *
 * Note that this does not robustly forbid non json comparable data via type checking,
 * but instead mostly restricts access to it.
 */
export type FluidSerializableReadOnly = IFluidHandle | string | number | boolean | null | readonly FluidSerializableReadOnly[] | {
    readonly [P in string]?: FluidSerializableReadOnly;
};
export declare function isFluidHandle(value: unknown): value is IFluidHandle;
export declare function assertAllowedValue(value: undefined | FluidSerializableReadOnly): asserts value is Value;
export declare function isAllowedValue(value: undefined | FluidSerializableReadOnly): value is Value;
//# sourceMappingURL=valueUtilities.d.ts.map