/*!
 * Copyright (c) Microsoft Corporation and contributors. All rights reserved.
 * Licensed under the MIT License.
 */
export { EmptyKey, AnchorSet, rootFieldKey, rootField, CursorLocationType, TreeNavigationResult, ITreeSubscriptionCursorState, ValueSchema, TreeNodeStoredSchema, anchorSlot, AllowedUpdateType, RevertibleKind, RevertResult, DiscardResult, forbiddenFieldKindIdentifier, } from "./core";
export { extractFromOpaque, brand, fail, TransactionResult, oneFromSet, disposeSymbol, } from "./util";
export { createEmitter, } from "./events";
export { leaf } from "./domains";
export { FieldKind as FlexFieldKind, Multiplicity, isNeverField, typeNameSymbol, valueSymbol, isContextuallyTypedNodeDataObject, defaultSchemaPolicy, jsonableTreeFromCursor, compareLocalNodeKeys, prefixPath, prefixFieldPath, cursorForJsonableTreeNode as singleTextCursor, stackTreeNodeCursor, FieldKinds, cursorFromContextualData, TreeFieldSchema, Any, cursorForTypedTreeData, nodeKeyFieldKey, TreeStatus, TreeNodeSchemaBase, FieldNodeSchema, LeafNodeSchema, MapNodeSchema, ObjectNodeSchema, SchemaBuilderBase, schemaIsFieldNode, schemaIsLeaf, schemaIsMap, schemaIsObjectNode, TreeCompressionStrategy, treeSchemaFromStoredSchema, encodeTreeSchema, stackTreeFieldCursor, } from "./feature-libraries";
export { TreeArrayNode, IterableTreeListContent, TreeNode, create, } from "./simple-tree";
export { runSynchronous, SharedTreeFactory, ForestType, buildTreeConfiguration, } from "./shared-tree";
export { TreeConfiguration, SchemaFactory, Tree, type, FieldKind, FieldSchema, NodeKind, 
// experimental @internal APIs:
adaptEnum, enumFromStrings, singletonSchema, typedObjectValues, 
// test recursive schema for checking that d.ts files handles schema correctly
test_RecursiveObject, test_RecursiveObject_base, } from "./class-tree";
export { SharedTree, TreeFactory } from "./treeFactory";
export { noopValidator } from "./codec";
export { typeboxValidator } from "./external-utilities";
// TODO: When previously tagged '@internal', these types could not be included in `InternalClassTreeTypes` due to https://github.com/microsoft/rushstack/issues/3639
export { BrandedType, ErasedType, } from "./util";
export { flexTreeMarker, FlexTreeEntityKind, } from "./feature-libraries";
//# sourceMappingURL=index.js.map